#ifndef _NEXT_JOYSTICK_KERNEL_H
#define _NEXT_JOYSTICK_KERNEL_H

#include "joystick.h"

#define HZ 100
#define JS_TRUE 1
#define JS_FALSE 0
#define JS_PORT 0x201		/*io port for joystick operations*/
#define JS_DEF_TIMEOUT 0x1300	/*default timeout value for js_read()*/
#define JS_DEF_CORR	0	/*default correction factor*/
#define JS_DEF_TIMELIMIT 10L	/*default data valid time =10 jiffies == 100ms*/

#define JS_X_0	0x01		/*bit mask for x-axis js0*/
#define JS_Y_0	0x02		/*bit mask for y-axis js0*/
#define JS_X_1	0x04		/*bit mask for x-axis js1*/
#define JS_Y_1	0x08		/*bit mask for y-axis js1*/

#define PIT_MODE 0x43		/*io port for timer 0*/
#define PIT_COUNTER_0 0x40	/*io port for timer 0*/

#define LATCH (1193180L/HZ)	/*initial timer 0 value*/
#define DELTA_TIME(X,Y) ((X)-(Y)+(((X)>=(Y))?0:LATCH))
// #define CURRENT_JIFFIES (jiffies)

#define TIMELIMIT	1
#define CURRENT_JIFFIES (clock_value(System) / 10000000ULL)

// #define	CLI_STI	1
#ifdef	CLI_STI
#define sti() __asm__ __volatile__ ("sti": : :"memory")
#define cli() __asm__ __volatile__ ("cli": : :"memory")
#endif	CLI_STI

#define linux_outb(DATA,ADDRESS)	outb(ADDRESS,DATA)
#define JOYSTICK_MAJOR		32


#endif /* _NEXT_JOYSTICK_KERNEL_H */
